// #pragma GCC optimize("O3,fast-math,unroll-loops")
#include <bits/stdc++.h>

#define i64 int64_t
#define vi vector<int>
#define vvi vector<vi>
#define vc vector
#define vb vc<bool>
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template <typename T>

istream& operator>>(istream& in, vector<T> &a) {
    for (T &el : a) in >> el;
    return in;
}

template <typename T>

ostream& operator<<(ostream& out, vector<T> a) {
    for (T &el : a) out << el << " ";
    return out;
}


void solve() {
    int T;
    cin >> T;
    int n, m;
    cin >> n >> m;
    vi a(n);
    cin >> a;
    string s;
    cin >> s;
    vi cnt(2);
    for (int i = 0; i < n; ++i) ++cnt[(i + a[i]) % 2];
    string ans1 = (a[0] % 2 == a[1] % 2 ? "Yes" : "No");
    vc<pii> ans;
    int cnt1 = 2 * m;
    int i = 0;
    if (ans1 == "No") {
        cout << ans1;
        return;
    }
    if (a[0] == a[1] && s[0] == s[1]) {
        cout << "Yes\n";
        if (T == 2) {
            cout << m;
            return;
        }
        if (T == 3) {
            cout << m << '\n';
            cout << 0 << '\n';
        }
        return;
    }
    while (cnt1--) {
        if (a[0] == a[1] && a[0] != m) {
            ans.pb({i, a[0]});
        }
        if (a[0] == m && s[0] == 'R') {
            a[0] = m - 1;
            s[0] = 'L';
        } else if (a[0] == 1 && s[0] == 'L') {
            a[0] = 2;
            s[0] = 'R';
        } else if (s[0] == 'L') {
            --a[0];
        } else {
            ++a[0];
        }

        if (a[1] == m && s[1] == 'R') {
            a[1] = m - 1;
            s[1] = 'L';
        } else if (a[1] == 1 && s[1] == 'L') {
            a[1] = 2;
            s[1] = 'R';
        } else if (s[1] == 'L') {
            --a[1];
        } else {
            ++a[1];
        }
        ++i;
    }
    if (!ans.size()) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    if (T == 1) return;
    sort(all(ans), [&](pii a, pii b) {
        if (a.se == b.se) return a.fi < b.fi;
        return a.se > b.se;
    });
    assert(ans.size());
    if (T == 2) {
        cout << ans[0].se;
        return;
    }
    cout << ans[0].se << '\n';
    cout << 1 << '\n';
    cout << ans[0].fi << " " << ans[0].se;
}

int32_t main() {
    // freopen("inputa.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}